import com.hp.hpl.jena.rdf.model.InfModel;
import com.hp.hpl.jena.reasoner.Reasoner;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.rdf.model.Property;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.rdf.model.Statement;
import com.hp.hpl.jena.rdf.model.StmtIterator;
import com.hp.hpl.jena.reasoner.ReasonerRegistry;
import com.hp.hpl.jena.util.FileManager;
import com.hp.hpl.jena.util.PrintUtil;
import com.hp.hpl.jena.vocabulary.RDF;


public class SchemaDemo {
	public static void main(String args[])
	{
		Model schema = FileManager.get().loadModel("owlDemoSchema.owl");
	    Model data = FileManager.get().loadModel("owlDemoData.rdf");
	    
	    Reasoner reasoner = ReasonerRegistry.getOWLReasoner();
	    reasoner = reasoner.bindSchema(schema);
	    InfModel infmodel = ModelFactory.createInfModel(reasoner, data);
	    
	    Resource nForce = infmodel.getResource("urn:x-hp:eg/nForce");
	    System.out.println("nForce *:");
	    printStatements(infmodel, nForce, null, null);
	    
	    Resource gamingComputer = infmodel.getResource("urn:x-hp:eg/GamingComputer");
	    Resource whiteBox = infmodel.getResource("urn:x-hp:eg/whiteBoxZX");
	    if (infmodel.contains(whiteBox, RDF.type, gamingComputer)) {
	        System.out.println("White box recognized as gaming computer");
	    } else {
	        System.out.println("Failed to recognize white box correctly");
	    }
	}
	public static void printStatements(Model m, Resource s, Property p, Resource o) {
        for (StmtIterator i = m.listStatements(s,p,o); i.hasNext(); ) {
            Statement stmt = i.nextStatement();
            System.out.println(" - " + PrintUtil.print(stmt));
        }
    }

}
